require 'stringio'

class Long
  attr_accessor :on_close
  attr_reader :status
  attr_reader :pid
  
  @@instances = {}
  
  def self.register(pid,instance)
    @@instances[pid.to_s]=instance
  end
  
  def self.unregister(pid)
    @@instances[pid.to_s]=nil
  end
  
  def self.instance(pid)
    @@instances[pid.to_s] || self.new
  end
  
  def initialize
    @status = :idle
    @pid = self.object_id
    
    $stdin = StringIO.new
    $stdout = StringIO.new
    $stderr = StringIO.new
  end
  
  
  def wait(seconds=30)
    catch(:exited) {
      (seconds*2).times {
        throw(:exited, true) if @status==:finished
        sleep 0.5
      }
      false
    }
  end
  
  def finished?
    @status == :finished
  end
  
  def write(line)
    $stdin.print(line) if @status == :running
  end
  
  alias << write
  
  def read
    $stdout.read
  end
  
  def read_err
    $stderr.read
  end
  
  def run(path, *params)
    return if @status == :running
    
    # do VERY LONG taking task
    
    self.id
  end
  
end