require 'haml' 

class Backrack::HamlRender
  def self.call(env)
    @request = Rack::Request.new(env)
    @response = Rack::Response.new
    
    Backrack.logger.debug(@request.path_info)
    
    path = @request.path_info
    if path =~ /\.html$/ || path =~ /\.haml$/
      cpath = File.join(Backrack.config[:view], path)
      spath = File.join(Backrack.config[:view], path[0..-5]+".haml")
      
      if File.exist?(spath) 
        if File.exist?(cpath) && File.mtime(cpath) >= File.mtime(spath)
          @response.write(File.read(cpath))
          return @response.finish
        else
          begin
            template = File.read(spath)  
            
            proxy = Backrack::TextProxy.new
            proxy._proxy_for(Object.new)
            
            haml_engine = Haml::Engine.new(template)   
            output = haml_engine.render(proxy)   
            
            @response.status = 200
            @response.write(output)
            File.open(cpath, "w") do |f|
              f.write(output)
            end
          rescue SyntaxError
            return [404, {'Content-Type' => 'text/html'}, "not valid haml"]
          end
        end
      else
        return [404, {'Content-Type' => 'text/html'}, "no file found"]
      end
    else
      [404, {'Content-Type' => 'text/html'}, "no haml file found"]
    end
  end
end
