require 'sass' 

class Backrack::SassRender
  def initialize(path)
    @base_path = path
  end

  def call(env)
    request = Rack::Request.new(env)
    response = Rack::Response.new
    
    Backrack.logger.debug(request.path_info)
    
    path = request.path_info
    if path =~ /\.css$/
      cpath = File.join(@base_path, path)
      spath = File.join(@base_path, path[0..-5]+".sass")
      
      if File.exist?(spath) 
        if File.exist?(cpath) && File.mtime(cpath) >= File.mtime(spath)
          content = File.read(cpath)
          response["Content-Type"] = "text/css"
          response.write(content.to_s)
          response.status = 200
          return response.finish
        else
          begin
            template = File.read(spath)  
            sass_engine = Sass::Engine.new(template)   
            output = sass_engine.render   
            
            response.status = 200
            response["Content-Type"] = "text/css"
            response.write(output)
            File.open(cpath, "w") do |f|
              f.write(output)
            end
            response.finish
          rescue SyntaxError
            return [404, {'Content-Type' => 'text/html'}, "no sass found"]
          end
        end
      else
        return [404, {'Content-Type' => 'text/html'}, "no sass found"]
      end
    else
      [404, {'Content-Type' => 'text/html'}, "no sass found"]
    end
  end
end
