unless defined?(Backrack::Cfg)

  require 'yaml'

  class Backrack::Cfg
    def self.init!
      @config ||= {}
    end
  
    def self.[]=(index,key)
      @config[index]= key 
    end
  
    def self.[](index)
      @config[index]
    end
  
    def self.load_from_yaml(path="config.yml", mode="development")
      $stderr.puts("LOADING FROM YAML #{path}") if $DEBUG
      nconf = YAML.load(File.read(path))
      @config = nconf.merge!(@config)
    end
  
    def self.save_to_yaml(path="config.yml")
      File.open(path, "w") do |f|
        f.write(YAML.dump(@config))
      end
    end
  
    def self.add_defaults(hash)
      @config = hash.merge(@config)
    end
    
    class << self
      attr_reader :config
    end
  
    init!
  end
end