require 'parse_tree'
require 'session'

class Backrack::Parasite
  @@classes ||= []
  @@classes_hash ||= {}
  @@mtime||={}
  attr_reader :attr_names
  
  def self.classes=(new_classes)
    @@classes = new_classes
    @@classes_hash = @@classes.inject({}){|hash, v|
      hash[v.to_s]=v; hash
    }
  end
  
  def self.add_class(new_class)
    @@classes += new_class
    @@classes_hash = @@classes.inject({}){|hash, v|
      hash[v.to_s]=v; hash
    }
  end
  
  def self.infest(klass)
    $backrack_log.debug "infesting #{klass.to_s}"
    
    # right now we're not infesting anything ;)
  end
  
  def self.discover!(use_load=false,provide=[])
    app_path = Backrack::Cfg[:path]
    $backrack_log.info "looking for stuff in #{app_path}"
    
    old_classes = []
    ObjectSpace.each_object(Module) do |klass|
      old_classes << klass
    end
    
    if File.directory? app_path
      Dir.glob(app_path+"/*.rb") { |filename|
        $backrack_log.debug "loading #{filename}"
        if @@mtime[filename] != File.mtime(filename)
          use_load ? Kernel.load(filename) : require(filename)
          @@mtime[filename] = File.mtime(filename)
        end   
      }
    else
      require app_path.split('.rb')[-1]
    end
    
    new_classes = []
    ObjectSpace.each_object(Module) do |klass|
      new_classes << klass
    end

    unless Backrack::Cfg[:provide]
      new_classes = new_classes - old_classes + [Backrack::Default]
    else
      new_classes = Backrack::Cfg[:provide].split(',').map { |class_name| Object.const_get(class_name) } + [Backrack::Default]
    end
    
    $backrack_log.debug new_classes
    
    new_classes.each{ |c| infest(c) }
    
    @@classes |= new_classes
    @@classes_hash = @@classes.inject({}){|hash, v|
      hash[v.to_s]=v; hash
    }
  end
  
  def self.classes
    @@classes
  end
  
  def self.classes_hash
    @@classes_hash
  end  
end
