class Session < Hash
  class << self
    def instance(session_key = nil)
      @session_instances ||= {}
      @session_instances[session_key] ||= Backrack::ObjectManager.register(new, session_key)
    end
  
    alias [] instance
    private :new
  end
  
  def session_id
    @_session_key  
  end
  
  def session_key
    @_session_key  
  end
  
  def id
    @_session_key  
  end
  
  def method_missing(name, *args, &block)
    name = name.to_s
    if name[-1..-1] == "="
      key = name[0..-2].to_sym
      self[key] = args[0]
    else
      key = name.to_sym
      self[key]
    end
  end
end


