  module BoundAndUnbound
    def to_sexp
      with_class_and_method_name do |klass, method|
        ParseTree.new(false).parse_tree_for_method(klass, method)
      end
    end
  
    def with_class_and_method_name
      if (self.inspect =~ /<Method: (.*)(\#|\.)(.*)>/) || (self.inspect =~ /<UnboundMethod: ([\w:]*).*(\#|\.)(.*)>/) then
        klass = $1.to_object
        method  = $3.intern
        klass = klass.metaclass if $2 == '.'              
        raise "Couldn't determine class from #{self.inspect}" if klass.nil?
        return yield(klass, method)
      else
        raise "Can't parse signature: #{self.inspect}"
      end
    end
  
    def params
      pr = self.to_sexp[2][1][1][1..-1] rescue []
      pr.select{|prr| prr.class == Symbol}
    end
  end

  class Method
    include BoundAndUnbound
  end

  class UnboundMethod
    include BoundAndUnbound
  end
