require 'json'

unless defined?(Backrack::JsonRPC) or defined?(Backrack::Json)
  class Backrack::Json
    Backrack::Dispatcher.register(["application/json-rpc;q=1","application/json;q=0.9", "text/javascript;q=0.7"], self)
    ALLOWED_RESULTS = [Array, Hash, String, Fixnum, Symbol, TrueClass,
      FalseClass, NilClass, Float, Date, Time, DateTime]

    attr_accessor :request, :response, :params, :session
  
    def wrap_result(o)
      if o.respond_to? :to_json
        o.to_json
      else
        o.to_s
      end
    end

    def wrap_error(e)
      @response.status = 422
      @response.write({"error" => e.to_s,}.to_json)
      return @response
    end

    def run(object, method_name, args)
      result = nil
      begin
        result = object.send(method_name, *args)
        if result == :ok
          @response.status = 200
          return(@response)
        end
        wrap_result(result)
      rescue Exception => e
        wrap_error(e)
      end
    end
  end
end