class Backrack::TextProxy
  if defined?(Backrack::ViewHelpers)
    include Backrack::ViewHelpers
    Backrack::ViewHelpers.constants.each do |c|
      include(Backrack::ViewHelpers.const_get(c))
    end
  end
  include GetText::ErbContainer
  include RPH::PrettyFlash::Display

  def _get_binding_with_block
    @_cached_binding = binding
  end

  def _proxy_for(object, serializer)
    @_proxied_object = object
    @_proxy_serializer = serializer
    self
  end

  def method_missing(name, *args, &block)
    if @_proxied_object && @_proxied_object.respond_to?(name)
      @_proxied_object.send(name, *args, &block)
    else
      raise( NoMethodError,
        "undefined method '#{name}' for #{@_proxied_object.inspect}",
        caller
      )
    end
  end

  def result
    @_cached_result = eval("yield",@_cached_binding)
  end

  define_method(:class) do
    @_proxied_object ? @_proxied_object.class : Backrack::TextProxy
  end

  def initialize(locale="pl")
    set_locale(locale)
  end

  def id
    @_proxied_object.id
  end
end