unless defined?(Backrack::XmlRPC) or defined?(Backrack::Xml)
  class Backrack::Xml
    Backrack::Dispatcher.register(["application/xml;q=0.9", "text/xml;q=0.9"], self)
  
    attr_accessor :request, :response, :params, :session
  
    def wrap_result(o)
      if o.respond_to? :to_xml
        o.to_xml
      else
        o.to_s
      end
    end
  
    def wrap_error(e)
      @response.status = 422
      @response.write({"error" => e.to_s,}.to_xml)
      return @response
    end
  
    def run(object, method_name, args)
      result = nil
      begin
        result = object.send(method_name, *args)
        if result == :ok
          @response.status = 200
          return(@response)
        end
        wrap_result(result)
      rescue Exception => e
        wrap_error(e)
      end
    end
  end
end