# 
# To change this template, choose Tools | Templates
# and open the template in the editor.
require 'xmlrpc/create'
require 'xmlrpc/parser'
require 'xmlrpc/config'
unless defined? Backrack::XmlRPC
class Backrack::XmlRPC
  Backrack::Dispatcher.register(["application/xml+rpc;q=1", "application/xml;q=1","text/xml;q=0.9"], self)
  
  ALLOWED_RESULTS = [Array, Hash, String, Fixnum, Symbol, 
    TrueClass, FalseClass, NilClass, Float, Date, Time, DateTime]

  attr_accessor :request, :response, :params, :session
  
  def initiaize
    @parser = XMLRPC::XMLParser::REXMLStreamParser.new
    @dumper = XMLRPC::Create.new
  end
  
  def load(xml_string)
    @parser.parseMethodCall(xml_string)
  end
  
  def wrap_result(o)
    [true, o]
  end
  
  def wrap_error(e)
    [false, XMLRPC::FaultException.new(4,e.to_s)]
  end
  
  def wrap_object(o)
    Backrack::ObjectManager.register(o, @session.id)
    {
      "object_id" => o.respond_to?(:id) ? o.id : o.object_id,
      "class_name" => o.class.to_s    
    }
  end
  
  def process_rpc_request(path, payload, post=true)
    path = path.split("/")[1..-1]
    
    class_name = path.shift || raise(NoMethodError)
    instance_id = path.shift
    
    request_params, method_name = [], nil # scope
    if request.post?
      rpc_request = self.load(payload)
      request_params = rpc_request[1]
      method_name = rpc_request[0]
    end
    [class_name, instance_id, method_name, request_params]
  end
  
  def run(object, method_name, args)
    request_response = begin
      result = object.send(method_name, *args)
      result = ALLOWED_RESULTS.any?{|c| result.kind_of?(c)} ? result : wrap_object(result)
      wrap_result(result)
    rescue Exception => e
      wrap_error(e)
    end
    @dumper.methodResponse(*request_response)
  end
end
end