require 'test/unit'
require 'rubygems'
require 'shoulda'

require 'tests/test_helper'
require 'json'
require 'ostruct'

Backrack.logger.level = Logger::DEBUG

class DebugSerializer
  def run(object, method_name, args)
    
  end
  
  def process_rpc_request(path, payload, post)
    
  end
end

class TestBackrack < Test::Unit::TestCase
  context "Backrack" do
    setup do
    end
    
    #    should "load serializers" do
    #      Backrack::Dispatcher.mime_types.clear
    #      Backrack.load_serializers(["text"])
    #      assert_equal(Backrack::Dispatcher.mime_types.keys.sort, [
    #          ["text", "*", {"q"=>"0.1"}], ["text", "html", {"q"=>"0.5"}],
    #          ["text", "plain", {"q"=>"1"}]
    #       ].sort)
    #    end
    #
    #    should "register serializers" do
    #      Backrack::Dispatcher.mime_types.clear
    #      Backrack::Dispatcher.register("text/test", DebugSerializer)
    #      assert_equal(Backrack::Dispatcher.mime_types.keys, [
    #          ["text", "test", {"q"=>"1"}]
    #       ])
    #    end
  end
  context "Process RPC request" do
    setup do
      @request = OpenStruct.new({
          :path_info => "/",
          :request_method => "get",
        })

      @d = Backrack::Dispatcher.new
    end

    should "parse basic paths correctly" do
      {
        "/" => [nil, nil, "get", {}],
        "/Klass" => ["Klass", nil, "get", {}],
        "/Klass/foo" => ["Klass", nil, "foo", {}],
        "/Klass/-1" => ["Klass", -1, "get", {}],
        "/Klass/-1/" => ["Klass", -1, "get", {}],
        "/Klass/-1/foo" => ["Klass", -1, "foo", {}],
        "/Klass/-1/foo/bar" => ["Klass", -1, "foo", ["bar"]],
        "/Klass/FOOBAR/foo/bar" => ["Klass", "FOOBAR", "foo", ["bar"]],
      }.each_pair do |k, v|
        request = @request.dup
        request.path_info = k
        assert_equal(v, @d.process_rpc_request(request), "wrong request for #{k}")
      end

      request = @request.dup
      request.path_info = "/Klass/-1/foo/baz"
      request.params = {"foo" => "bar"}

      assert_equal(["Klass", -1, "foo", {"foo" => "bar"}],
        @d.process_rpc_request(request), "wrong request for /Klass/-1/foo")
    end
  end
end