require 'test/unit'
require 'rubygems'
require 'shoulda'

require 'backrack'
require 'backrack/mimeparse'

class TestMimeParse < Test::Unit::TestCase
  @@supported = [
    "text/xml;q=1", #0
    "text/*;q=0.9", #1
    "application/json;q=1", #2
    "text/javascript;q=0.7", #3
    "text/javascript", #4
    "*/*;q=1", #5
    "text/html;q=0.1", #6
  ]

  @@accepted = {
    "fake/type" => 5,
    "text/html" => 6,
    "*/*" => 5,
    "text/xml" => 0,
    "*/json"=> 2,
    "text/javascript" => 4,
    "text/xml;q=0.1, text/html;q=0.9" => 6,
    "application/json" => 2,
  }

  @@accepted.each do |mt, i|
    expected = @@supported[i].dup
    supported = @@supported.dup
    should "assign #{mt} to #{expected}" do
      result = MIMEParse.best_match(supported, mt)
      assert_equal(expected, result)
    end
  end
end

